// |-------------------------------------------|
// | Antifreeze Hack (monster)                 |
// | by: madsiur                               |
// | version: 1.0a                             |
// | released on: Frebruary 12th, 2022         |
// | apply to: FF3us 1.0 (no header)           |
// |-------------------------------------------|

arch snes.cpu

macro seek(variable offset) {
  origin (offset & $3FFFFF)
  base offset
}

// monster properties setting hook
seek($C22E24)
jsr free_space

seek($EEAF01)       // free space in another bank that $C2
free_space:
sta $331C,y         // original code
lda $CF0014,x       // monster blocked status bytes 1-2
bit #$0008          // check if the "block magitek" flag is set
beq exit            // exit if not
lda #$FDFF          // not vulnerable to Freeze
and $3330,y
sta $3330,y         // make monster not vulnerable to Freeze
exit:
rts
